package cn.com.infosec.crypto.generators;

import java.math.BigInteger;
import java.security.SecureRandom;

class DHKeyGeneratorHelper {
   private static final int MAX_ITERATIONS = 1000;
   static final DHKeyGeneratorHelper INSTANCE = new DHKeyGeneratorHelper();
   private static final BigInteger ZERO = BigInteger.valueOf(0L);
   private static final BigInteger TWO = BigInteger.valueOf(2L);

   private DHKeyGeneratorHelper() {
   }

   private BigInteger createInRange(BigInteger max, SecureRandom random) {
      int var5 = max.bitLength();
      int var3 = 0;

      BigInteger var10000;
      BigInteger var4;
      do {
         var10000 = var4 = new BigInteger;
         var10000.<init>(var5, random);
         ++var3;
      } while((var10000.equals(ZERO) || var4.compareTo(max) > 0) && var3 != 1000);

      return var3 == 1000 ? (new BigInteger(var5 - 1, random)).setBit(0) : var4;
   }

   BigInteger calculatePrivate(BigInteger p, SecureRandom random, int limit) {
      p = p.subtract(TWO);
      BigInteger var10000;
      BigInteger var4;
      if (limit == 0) {
         var4 = this.createInRange(p, random);
      } else {
         do {
            var10000 = var4 = new BigInteger;
            var10000.<init>(limit, 0, random);
         } while(var10000.equals(ZERO));
      }

      return var4;
   }

   BigInteger calculatePublic(BigInteger p, BigInteger g, BigInteger x) {
      return g.modPow(x, p);
   }
}
